UNIT UMainForm;

INTERFACE

USES
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, xmldom, XMLIntf, msxmldom, XMLDoc,
  IdBaseComponent, IdComponent, IdTCPConnection, IdTCPClient, IdHTTP,
  ExtCtrls, OleCtrls, SHDocVw, IdAntiFreezeBase, IdAntiFreeze, 
  ImgList;

TYPE
  TMainForm = CLASS(TForm)
    ServicesView: TTreeView;
    HostEdit: TEdit;
    ConnectButton: TButton;
    HostGroupBox: TGroupBox;
    Label1: TLabel;
    PortEdit: TEdit;
    Label4: TLabel;
    ParametersGroupBox: TGroupBox;
    NameRButton: TRadioButton;
    MonikerRButton: TRadioButton;
    Label5: TLabel;
    Bevel1: TBevel;
    ExCheckBox: TCheckBox;
    StatusBar: TStatusBar;
    CaptureButton: TButton;
    Image1: TImage;
    ConfigGroupBox: TGroupBox;
    ConfigWebBrowser: TWebBrowser;
    ItemsGroupBox: TGroupBox;
    ProxyGroupBox: TGroupBox;
    Label2: TLabel;
    Label3: TLabel;
    ProxyServerEdit: TEdit;
    ProxyPortEdit: TEdit;
    MyImageList: TImageList;

    Procedure ConnectButtonClick(Sender: TObject);
    Procedure ServicesViewDeletion(Sender: TObject; Node: TTreeNode);
    Procedure ServicesViewClick(Sender: TObject);
    Procedure FormCreate(Sender: TObject);
    Procedure UpdateActiveGoalService;
    Procedure NameRButtonClick(Sender: TObject);
    Procedure MonikerRButtonClick(Sender: TObject);
    Procedure ExCheckBoxClick(Sender: TObject);
    Procedure CaptureButtonClick(Sender: TObject);
    Procedure HostEditKeyPress(Sender: TObject; Var Key: Char);

  End;

TYPE
  TGoalService = CLASS
  PUBLIC
    Port: String;
    Host: String;
    Path: String;
    Moniker: String;
    GrandChild: Boolean;
    CONSTRUCTOR Create;
    Function GetURL(AccessByMoniker, ExtendedInfo: Boolean): String;
    Function GetConfigURL(AccessByMoniker, ExtendedInfo: Boolean): String;
  End;

Var
  MainForm          : TMainForm;

IMPLEMENTATION

{$R *.dfm}
USES idURI, ShellAPI, UCaptureForm;

Var
  ActiveGoalService : TGoalService;
  CaptureForm    : TCaptureForm;

Procedure TMainForm.ConnectButtonClick(Sender: TObject);
Var
  HTTPText          : TMemoryStream;
  XML               : IXMLDocument;
  HTTP              : TidHTTP;
  I, J, K           : LongInt;

  SXMLNode          : IXMLNode;
  CXMLNode          : IXMLNode;
  GXMLNode          : IXMLNode;

  TreeRoot          : TTreeNode;
  STreeNode         : TTreeNode;
  CTreeNode         : TTreeNode;
  GTreeNode         : TTreeNode;

  URL               : TidURI;

  GoalService       : TGoalService;

Begin
  ServicesView.Items.Clear; StatusBar.SimpleText := 'Connecting to server ...'; ConnectButton.Enabled := False;

  TRY
    HTTPText := TMemoryStream.Create;

    URL := TidURI.Create;
    URL.Protocol := 'http';
    URL.Host := HostEdit.Text;
    URL.Port := PortEdit.Text;
    URL.Path := '/enum/all';

    HTTP := TidHTTP.Create(NIL);

    If (ProxyServerEdit.Text <> '') Then
    Begin
       HTTP.ProxyParams.ProxyServer := ProxyServerEdit.Text;
       HTTP.ProxyParams.ProxyPort := StrToInt(ProxyPortEdit.Text)
    End;

    HTTP.ReadTimeout := 10000;
    HTTP.HTTPOptions := HTTP.HTTPOptions + [hoInProcessAuth];
    HTTP.Request.BasicAuthentication := True;
    HTTP.Get(URL.URI, HTTPText);

    StatusBar.SimpleText := Format('Connecting to server ... Done! %d bytes recived.', [HTTPText.Size]);

    If (Pos('text/xml', HTTP.Response.ContentType) > 0) Then
      Begin
        TRY
          XML := TXMLDocument.Create(NIL); XML.Active := True;
          XML.LoadFromStream(HTTPText);

          SXMLNode := XML.DocumentElement.ChildNodes['servers'];

          TReeRoot := ServicesView.Items.AddChildObjectFirst(NIL, XML.DocumentElement.ChildNodes['name'].Text, NIL);

          FOR I := 0 TO SXMLNode.ChildNodes.Count - 1 DO
            Begin

              GoalService := TGoalService.Create;
              GoalService.Host := HostEdit.Text;
              GoalService.Port := PortEdit.Text;
              GoalService.Path := SXMLNode.ChildNodes[I].ChildNodes['clsid'].Text;
              GoalService.Moniker := SXMLNode.ChildNodes[I].ChildNodes['moniker'].Text;
              GoalService.GrandChild := False;

              STreeNode := ServicesView.Items.AddChildObject(TreeRoot, SXMLNode.ChildNodes[I].ChildNodes['description'].Text, GoalService);

              CXMLNode := SXMLNode.ChildNodes[I].ChildNodes['children'];

              FOR J := 0 TO CXMLNode.ChildNodes.Count - 1 DO
                Begin

                  GoalService := TGoalService.Create;
                  GoalService.Host := HostEdit.Text;
                  GoalService.Port := PortEdit.Text;
                  GoalService.Path := SXMLNode.ChildNodes[I].ChildNodes['clsid'].Text + '/' + CXMLNode.ChildNodes[J].ChildNodes['description'].Text;
                  GoalService.Moniker := CXMLNode.ChildNodes[J].ChildNodes['moniker'].Text;
                  GoalService.GrandChild := False;

                  CTreeNode := ServicesView.Items.AddChildObject(STreeNode, CXMLNode.ChildNodes[J].ChildNodes['description'].Text, GoalService);

                  GXMLNode := CXMLNode.ChildNodes[J].ChildNodes['grandchildren'];

                  FOR K := 0 TO GXMLNode.ChildNodes.Count - 1 DO
                    Begin

                      GoalService := TGoalService.Create;
                      GoalService.Host := HostEdit.Text;
                      GoalService.Port := PortEdit.Text;
                      GoalService.Path := SXMLNode.ChildNodes[I].ChildNodes['clsid'].Text + '/' +
                        CXMLNode.ChildNodes[J].ChildNodes['description'].Text + '/' +
                        GXMLNode.ChildNodes[K].ChildNodes['description'].Text;
                      GoalService.Moniker := GXMLNode.ChildNodes[K].ChildNodes['moniker'].Text;
                      GoalService.GrandChild := True;

                      GTreeNode := ServicesView.Items.AddChildObject(CTreeNode, GXMLNode.ChildNodes[K].ChildNodes['description'].Text, GoalService);

                      try
                       If (GXMLNode.ChildNodes[K].ChildNodes['videosignal'].Text = 'true') Then
                         GTreeNode.ImageIndex := 1
                       else
                         GTreeNode.ImageIndex := 2;
                      except

                      End;
                    End;
                End;
            End;
          XML.Active := False;
        EXCEPT
          ON E: Exception DO
            StatusBar.SimpleText := 'Connecting to server ... Failed! ' + E.Message;
        End;
      End
    ELSE
      StatusBar.SimpleText := 'Connecting to server ... Failed!';
    URL.Free; HTTP.Free; HTTPText.Free;
  EXCEPT
    ON E: Exception DO
      StatusBar.SimpleText := 'Connecting to server ... Failed! ' + E.Message;
  End;
  ConnectButton.Enabled := True;
End;

Procedure TMainForm.ServicesViewDeletion(Sender: TObject; Node: TTreeNode);
Begin
  If (Node.Data <> NIL) Then
    Begin
      If (ActiveGoalService = Node.Data) Then ActiveGoalService := NIL;
      TGoalService(Node.Data).Free;
    End;
  Node.Data := NIL;
End;

{ TGoalService }

CONSTRUCTOR TGoalService.Create;
Begin
  Port := ''; Host := '';
  Path := ''; Moniker := '';
  GrandChild := False;
End;

Function TGoalService.GetConfigURL(AccessByMoniker, ExtendedInfo: Boolean): String;
Var
  URL               : TidURI;
Begin
  URL := TidURI.Create;
  URL.Protocol := 'http';
  URL.Host := Host;
  URL.Port := Port;

  If (AccessByMoniker) Then URL.Path := '/' + TidURI.PathEncode(Moniker)
  ELSE
    URL.Path := '/' + TidURI.PathEncode(Path);

  URL.Params := '/config';

  Result := URL.URI; URL.Free;
End;

Function TGoalService.GetURL(AccessByMoniker, ExtendedInfo: Boolean): String;
Var
  URL               : TidURI;
Begin
  URL := TidURI.Create;
  URL.Protocol := 'http';
  URL.Host := Host;
  URL.Port := Port;

  If (AccessByMoniker) Then URL.Path := '/' + TidURI.PathEncode(Moniker)
  ELSE
    URL.Path := '/' + TidURI.PathEncode(Path);
  If (NOT GrandChild) Then URL.Params := '/enum'
  ELSE
    If (ExtendedInfo) Then URL.Params := '/video?info'
    ELSE
      URL.Params := '/video?jpeg';

  Result := URL.URI; URL.Free;
End;

Procedure TMainForm.ServicesViewClick(Sender: TObject);
Begin
  If (ServicesView.Selected.Data <> NIL) Then ActiveGoalService := ServicesView.Selected.Data;
  UpdateActiveGoalService;
End;

Procedure TMainForm.FormCreate(Sender: TObject);
Begin
  ShowMessage('        '
            + '      GoalCity. ' +
              '       . ' +
              '  , :' + #13 +
              '1.   GoalCity    4.0' + #13 +
              '2.     SpecLab.');
  DoubleBuffered := True;
  ActiveGoalService := NIL;
End;

Procedure TMainForm.UpdateActiveGoalService;
Begin
  StatusBar.SimpleText := '';
  If (ActiveGoalService = NIL) Then Exit;
  StatusBar.SimpleText := ActiveGoalService.GetURL(MonikerRButton.Checked, ExCheckBox.Checked);
  ConfigWebBrowser.Navigate(ActiveGoalService.GetConfigURL(MonikerRButton.Checked, ExCheckBox.Checked));
End;

Procedure TMainForm.NameRButtonClick(Sender: TObject);
Begin
  UpdateActiveGoalService;
End;

Procedure TMainForm.MonikerRButtonClick(Sender: TObject);
Begin
  UpdateActiveGoalService;
End;

Procedure TMainForm.ExCheckBoxClick(Sender: TObject);
Begin
  UpdateActiveGoalService;
End;

Procedure TMainForm.CaptureButtonClick(Sender: TObject);
Begin
  If (ActiveGoalService = NIL) Then Exit;
  If (CaptureForm = Nil) Then
    CaptureForm := TCaptureForm.Create(self);
  CaptureForm.Show;
  CaptureForm.Capture(ActiveGoalService.GetURL(MonikerRButton.Checked, ExCheckBox.Checked));
End;

Procedure TMainForm.HostEditKeyPress(Sender: TObject; Var Key: Char);
Begin
  If (Key = #13) Then ConnectButtonClick(NIL);
End;

End.

