UNIT UCommon;

INTERFACE

CONST
  SL_REALTIME       = 1;
  SL_ARCHIVE        = 2;

TYPE
  PSpeclabSource = ^TSpeclabSource;
  TSpeclabSource = RECORD
    Flag : LongInt;
    Name, Moniker : STRING;
    HostIP, HostPort, UserName, Password : STRING;
  END;

FUNCTION FixupMoniker(CONST ASrc : STRING) : STRING;

IMPLEMENTATION

USES SysUtils;

FUNCTION FixupMoniker(CONST ASrc : STRING) : STRING;
CONST
  UnsafeChars       = ['*', '#', '%', '<', '>', '+', ' ', '/'];
VAR
  i                 : Integer;
BEGIN
  Result := '';
  FOR i := 1 TO Length(ASrc) DO
    BEGIN
      IF (ASrc[i] IN UnsafeChars) OR (ASrc[i] >= #$80) OR (ASrc[1] < #32) THEN
        BEGIN
          Result := Result + '%' + IntToHex(Ord(ASrc[i]), 2);
        END ELSE
        BEGIN
          Result := Result + ASrc[i];
        END;
    END;
END;

END.
