<?xml version="1.0" encoding="windows-1251"?>
<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:msxsl="urn:schemas-microsoft-com:xslt"
>
<xsl:param name="sortby" select="'time'"/>
<xsl:param name="order" select="'ascending'"/>

<xsl:template match="/">
	<style type="text/css">
		.text{COLOR: #000000; FONT-FAMILY: Arial, Helvetica, sans-serif; FONT-SIZE: 12px; TEXT-DECORATION: none; font-weight: normal; width: 100%}
	</style>
<body bgcolor='#CCCCCC' onload='OnLoad()'>
	<h3>
		sortby: '<xsl:value-of select="$sortby"/>' order: '<xsl:value-of select="$order"/>'
	</h3>
	Color Threads<input type="checkbox" onclick="ColorizeThreads(this.checked)"/>
	<table border='1' cellpadding='0' cellspacing='0' align='center' width='100%' class="text" id='oTableMain'>
		<th><tr align='center'>
			<td onclick='SortBy("kind", "{$order}")' style='cursor: hand'>kind</td>
			<td onclick='SortBy("function", "{$order}")' style='cursor: hand'>function</td>
			<td onclick='SortBy("threadid", "{$order}")' style='cursor: hand'>threadid</td>
			<td onclick='SortBy("time", "{$order}")' style='cursor: hand'>time</td>
			<td onclick='SortBy("text", "{$order}")' style='cursor: hand'>text</td>
			<td onclick='SortBy("file", "{$order}")' style='cursor: hand'>fileline</td>
		</tr></th>
		<tr align='center'>
			<td>
				<table cellpadding='0' cellspacing='0' align='center' width='100%' class='text'>
					<xsl:for-each select="//tag/@kind[not(.=preceding::tag/@kind)]">
						<tr align='left'><td>
							<input type='checkbox' onclick='Hide("kind", "{.}", this.checked)' checked='checked'/><a href='#{.}'/><xsl:value-of select="."/>
						</td></tr>
					</xsl:for-each>
          <tr align='left'>
            <td>
              <input type='checkbox' onclick='Hide("kind", "", this.checked)' checked='checked'/>all
            </td>
          </tr>
        </table>
			</td>
			<td>
				<table cellpadding='0' cellspacing='0' align='center' width='100%' class='text'>
					<xsl:variable name="functions" select="//tag/@function[not(.=preceding::tag/@function)]"/>
					<xsl:for-each select="$functions">
            <xsl:sort order="ascending" select="."/>
						<tr align='left'><td>
							<input type='checkbox' onclick='Hide("function", "{.}", this.checked)' checked='checked'/><xsl:value-of select="."/>
						</td></tr>
					</xsl:for-each>
          <tr align='left'>
            <td>
              <input type='checkbox' onclick='Hide("function", "", this.checked)' checked='checked'/>all
            </td>
          </tr>
        </table>
			</td>
			<td>
				<table cellpadding='0' cellspacing='0' align='center' width='100%' class='text'>
					<tbody>
						<xsl:for-each select="//tag/@threadid[not(.=preceding::tag/@threadid)]">
              <xsl:sort order="ascending" select="." data-type="number"/>
							<tr align='left'><td>
								<input type='checkbox' onclick='Hide("threadid", "{.}", this.checked)' checked='checked'/><xsl:value-of select="."/>
							</td></tr>
						</xsl:for-each>
            <tr align='left'>
              <td>
                <input type='checkbox' onclick='Hide("threadid", "", this.checked)' checked='checked'/>all
              </td>
            </tr>
          </tbody>
				</table>
			</td>
			<td>
				<table class='text'>
					<tr><td>
						<select id='oSelTimeFrom' onchange='FilterTime(oSelTimeFrom.options[oSelTimeFrom.selectedIndex].value, oSelTimeTo.options[oSelTimeTo.selectedIndex].value)'>
							<xsl:for-each select="//tag/@time[not(.=preceding::tag/@time)]">
								<xsl:sort select="."/>
								<option value='{.}'><xsl:value-of select="."/></option>
							</xsl:for-each>
						</select>
					</td></tr>
					<tr><td>
						<select id='oSelTimeTo' onchange="FilterTime(oSelTimeFrom.options[oSelTimeFrom.selectedIndex].value, oSelTimeTo.options[oSelTimeTo.selectedIndex].value)">
							<xsl:for-each select="//tag/@time[not(.=preceding::tag/@time)]">
								<xsl:sort select="." order='descending'/>
								<option value='{.}'><xsl:value-of select="."/></option>
							</xsl:for-each>
						</select>
					</td></tr>
				</table>
			</td>
			<td>
				<table class='text'>
					<tr valign='middle' align='center'>
						<td width='100%'>
							<input type='checkbox' id='oNegationFilter' onclick='FilterText(oFilter.value, this.checked)'/>negate <input id='oFilter' type='text' style="width:100%; text-align:center;" onkeyup='FilterText(this.value, oNegationFilter.checked)'/>
						</td>
					</tr>
				</table>
			</td>
			<td>
				<table cellpadding='0' cellspacing='0' align='center' width='100%' class='text'>
					<xsl:for-each select="//tag/@file[not(.=preceding::tag/@file)]">
						<tr align='left'><td>
							<input type='checkbox' onclick='Hide("file", this.value, this.checked)' checked='checked' value='{.}'><xsl:value-of select="."/></input>
						</td></tr>
					</xsl:for-each>
				</table>
			</td>
		</tr>
		<xsl:for-each select="//tag">
			<xsl:sort select='attribute::*[name()=$sortby]' order='{$order}' data-type='text'/>
			<tr align='left' id="oLine">
				<td id='kind' align='center' ondblclick='Hide("kind", "{@kind}", 0)'><a name="{@kind}"/><xsl:value-of select="@kind"/></td>
				<td id='function' align='center' ondblclick='Hide("function", "{@function}", 0)'><xsl:value-of select="@function"/></td>
				<td id='threadid' align='center' ondblclick='Hide("threadid", "{@threadid}", 0)'><xsl:value-of select="@threadid"/></td>
				<td id='time' align='center'><xsl:value-of select="@time"/></td>
				<td id='text'>
					<xsl:copy-of select="node()"/>
				</td>
				<td id='file'>
					<table cellpadding='0' cellspacing='0' align='center' class='text'>
						<tr><td>
						<a style='cursor: hand' onclick='vbscript: OpenInMsvc "{@file}", "{@line}" '><xsl:value-of select="@file"/>(<xsl:value-of select="@line"/>)</a>
						</td></tr>
						<tr style='display:none'>
							<td>
								<table cellpadding='0' cellspacing='0' align='center' class='text' width='100%' border='1'>
									<xsl:for-each select="stack/frame">
									<tr>
										<td width='50%'><a style='cursor: hand' onclick='vbscript: OpenInMsvc "{@file}", "{@line}" '><xsl:value-of select="@file"/>(<xsl:value-of select="@line"/>)</a></td>
										<td><xsl:value-of select="@function"/></td>
									</tr>
									</xsl:for-each>
								</table>
							</td>
						</tr>
					</table>
				</td>
			</tr>
		</xsl:for-each>
	</table>
</body>
	<script language='vbscript'>
		<![CDATA[
		sub Hide(name, value, bHide)
			disp="none"
			if (bHide) then disp=""
			for each el in document.all(name)
				if left(el.innerText, len(value))=value or value="" then
					el.parentElement.style.display=disp
				end if
			next
		end sub
		
		sub FilterTime(from, unto)
			for each el in document.all("time")
				if between(el.innerText, from, unto) then
					el.parentElement.style.display=""
				else
					el.parentElement.style.display="none"
				end if
			next
		end sub
		
		function LessEq(a, b)
			res=StrComp(a, b)
			LessEq = (res=-1 or res=0)
		end function
		
		function MoreEq(a, b)
			res=StrComp(a, b)
			MoreEq = (res=1 or res=0)
		end function
		
		function between(val, left, right)
			between = (MoreEq(val, left) and LessEq(val, right))
		end function
		
		sub FilterText(text, negation)
			dim hide
			for each el in document.all("text")
				if instr(el.innerText, text)=0 then 
					hide=not negation
				else 
					hide=negation
				end if
				if  hide then
					el.parentElement.style.display="none"
				else
					el.parentElement.style.display=""
				end if
			next
		end sub
		
		function GetCurrentFolder()
			str=window.location
			pos=InStrRev(str, "/")
			res=""
			if (Left(str, 8)="file:///") then
				res = mid(str, 9, pos-8)
			else
				res = mid(str, 6, pos-5)
			end if
			res = Replace(res, "/", "\")
			GetCurrentFolder = res
		end function
		
		sub CheckAndCreateVsRuler(filename)
			Dim fso, MyFile
			Set fso = CreateObject("Scripting.FileSystemObject")
			if (not fso.FileExists(filename)) then
				Set MyFile = fso.CreateTextFile(filename, True)
				MyFile.WriteLine("if (WScript.Arguments.count=2) then")
				MyFile.WriteLine("Set DTE = GetObject(, ""VisualStudio.DTE.8.0"")")
				MyFile.WriteLine("DTE.Solution.FindProjectItem(WScript.Arguments(0)).Open()")
				MyFile.WriteLine("DTE.ActiveDocument.Selection.GotoLine WScript.Arguments(1), False")
				MyFile.WriteLine("DTE.MainWindow.Activate")
				MyFile.WriteLine("end if")
				MyFile.Close
			end if
		end sub
		
		sub OpenInMsvc(file, line)
			Set wss = CreateObject("WScript.Shell")
			filename=GetCurrentFolder() + "vsruler.vbs"
			CheckAndCreateVsRuler(filename)
			cmdline=filename + " " + file + " " + line 
			wss.run(cmdline)
		end sub	
		
		sub FindSourceLinks()
			set regexp = new RegExp
			regexp.global=true
			regexp.ignorecase=true
			nameset="[^/\\:\*\?""<>|]"
			pattern="[A-Z]:\\" + "([A-Z]+\\)*" + "[A-Z]+\.[A-Z]*\(\d+\)"
			szFileLinePattern=Replace(pattern,"nameset", nameset)
			szLinePattern="\(\d+\)"
			for each texttag in document.all("text")
				regexp.pattern=szFileLinePattern
				dim text, file
				text=texttag.innerHtml
				set matches=regexp.Execute(text)
				for each match in matches
					regexp.pattern=szLinePattern
					line=regexp.Execute(match.value).Item(0).value
					file=Replace(match.value, line, "")
					line=mid(line,2,len(line)-2)
					lt=chr(60)
					gt=chr(62)
					link= lt+"a style='cursor: hand' onclick='vbscript: OpenInMsvc """+file+""", """+line+"""'"+gt+""+match.value+""+lt+"a"+gt
					texttag.innerHtml=replace(texttag.innerHtml,match.value,link)
				next
			next
		end sub
		
		sub ColorizeThreads(bColorOn)
			for each tr in oLine
				ColorizeLine tr, bColorOn
			next
		end sub
	
		]]>

	</script>
	
	<script language='jscript'>
		function ColorizeLine(tr, bColorOn){
				var threadid=tr.all('threadid');
				tr.style.backgroundColor=bColorOn?0xFFFFFF-threadid.innerText:0xCCCCCC;
		}
		
		function OnLoad(){
			FindSourceLinks();	
		}
		
		function SortBy(name, order)
		  {
			order = (order=="descending")?"ascending":"descending";
			xml  = new ActiveXObject("Msxml2.DOMDocument.3.0");
			xml.async=false;
			xml.load(document.URL);
			
			xslt = new ActiveXObject("Msxml2.FreeThreadedDOMDocument.3.0");
			xslt.async=false;
			xslt.load("XmlTrace.xsl");
			
			xslTemp = new ActiveXObject("Msxml2.XSLTemplate.3.0");
			xslTemp.stylesheet = xslt;
			     
			xslProc = xslTemp.createProcessor();
			xslProc.input = xml;
			xslProc.addParameter("sortby", name);
			xslProc.addParameter("order", order);
			
			try { 
				xslProc.transform;
				document.open();
				document.write(xslProc.output);
				document.close();
			} catch(e) {
				alert(e.description)
			}
		  }
		
		function ShowStack(btn, td){
			if (td.style.display=="none"){
				btn.checked=true;
				td.style.display="";
			}  else {
				btn.checked=false;
				td.style.display="none";
			}
		}
	</script>
</xsl:template>
</xsl:stylesheet>
